class EdgeT{
  int S,E;// index into the vertice array
  int used;
  EdgeT(int s,int e)
  {
    S=s;
    E=e;
    used=0;
  }
  void setTo(EdgeT ed)
  {
    S=ed.S;
    E=ed.E;
    used=ed.used;
  }
  void make(int s,int e)
  {
    S=s;
    E=e;
    used=0;
  }
  void drawEdge(Triangulate3D T)
  {
    if(debug==true)
    {
      //				print("drawEdge:"+S+","+E+"\n");
    }
    if(used==1)
      stroke(dgreen);
    GT[S].showSegmentTo(GT[E]);
  }
  float	disToPt(Triangulate3D T,pt p)// return the distance of a point to this edge
  {	
    vec Sp=GT[S].makeVecTo(p);
    vec SE=GT[S].makeVecTo(GT[E]);
    vec N=SE.makeTurnedLeft();
    N.scaleBy(-1);
    N.normalize();
    float dotp=dot(Sp,SE);
    if(dotp>0 && dotp<dot(SE,SE))
    {
      return abs(dot(Sp,N));
    }
    else
    {

      float dS=p.disTo(GT[S]);
      float dE=p.disTo(GT[E]);
      if(dS<dE)
        return dS;
      else
        return dE;
    }
  }

}

class Triangulate3D
{
  int cap=10000;
  EdgeT []edge=new EdgeT[cap];
  //pt[] GT = new pt [cap];     // control points
  int nGT1,nedge;	
  int []V=new int[cap];
  int nV=0;
  p3 []GT3=new p3[cap];
  int nGT3;
  int polyloopVerticesTillHere;
  void fillGT3FromGT()
  {
    for(nGT3=0;nGT3<nGT;nGT3++)
    {
      GT3[nGT3].setTo(GT[nGT3].x, GT[nGT3].y,(G[int(GT[nGT3].x/h)][int(GT[nGT3].y/h)].z));
      if(nGT3<polyloopVerticesTillHere)
        GT3[nGT3].z=-10;
    }


  }
  void addMirrorMesh()
  {
    int tnGT3=nGT3;
    for(int i=polyloopVerticesTillHere;i<tnGT3;i++)
    {
      GT3[nGT3++].setTo(GT3[i].x,GT3[i].y,-GT3[i].z);
    }
    int tnV=nV;
    for(int i=0;i<tnV-3;i+=3)
    {
      if(V[i]<polyloopVerticesTillHere)
        V[nV++]=V[i];
      else
        V[nV++]=tnGT3+V[i]-polyloopVerticesTillHere;

      if(V[i+2]<polyloopVerticesTillHere)
        V[nV++]=V[i+2];
      else
        V[nV++]=tnGT3+V[i+2]-polyloopVerticesTillHere;

      if(V[i+1]<polyloopVerticesTillHere)
        V[nV++]=V[i+1];
      else
        V[nV++]=tnGT3+V[i+1]-polyloopVerticesTillHere;

    }		

  }
  void saveMesh() {
    String [] inppts = new String [nV/3+1+nGT3+1];
    int s=0;
    inppts[s++]=str(nGT3);
    for (int i=0; i<nGT3; i++) {
      inppts[s++]=str(GT3[i].x)+","+str(GT3[i].y)+","+str(GT3[i].z);
    };
    inppts[s++]=str(nV/3);
    for (int i=0; i<nV; i+=3) {
      inppts[s++]=str(V[i])+","+str(V[i+2])+","+str(V[i+1]);
    };
    saveStrings("..\\meshes\\mesh.vts",inppts);  
    println("saved on file");
  };
  void RenderTriangleMesh()
  {

    for(int i=0;i<nV-3;i+=3)
    {
      GT3[V[i]].showLineTo(GT3[V[i+1]]);
      GT3[V[i+1]].showLineTo(GT3[V[i+2]]);
      GT3[V[i+2]].showLineTo(GT3[V[i]]);
    }
  }

  Triangulate3D()
  {
    int i=0;
    for(i=0;i<cap;i++)
    {
      edge[i]=new EdgeT(-1,-1);
      GT3[i]=new p3(0,0,0);
    }
    i=0;
    nedge=0;
    polyloopVerticesTillHere=nGT;
    for(i=0;i<nloops;i++)
    {
      for(int j=0;j<LOOPS[i].nVi;j++)
      {
        if(j==LOOPS[i].nVi-1)
          edge[nedge++].make(LOOPS[i].Vi[j],LOOPS[i].Vi[0]);
        else
          edge[nedge++].make(LOOPS[i].Vi[j],LOOPS[i].Vi[j+1]);
      }
    }

  }
  void ShowEdges()
  {
    for(int i=0;i<nedge;i++)
    {
      edge[i].drawEdge(this);
    }
  }
  void appendVertex(pt V)
  {
    GT[nGT++]=V;
  }
  void DistributePoints()// shoot a normal from the mid point of the edge and mark points on it
  {
    for(int j=0;j<nGT;j++)
      GT[j].show(2);

    for(int i=0;i<nedge;i++)
    {
      pt M=new pt(0,0);
      M.setTo(GT[edge[i].S]);
      M.addPt(GT[edge[i].E]);
      M.scaleBy(.5);
      vec N=GT[edge[i].S].makeVecTo(GT[edge[i].E]);
      N.turnLeft();
      N.scaleBy(-1);
      N.normalize();
      //print("normal"+N.x+","+N.y+"\n");
      int foundedge=0;
      M.show(2);
      for(float j=0;foundedge==0&&j<1000;j++)
      {
        pt R=new pt(0,0);
        R.setTo(M.x+N.x*j,M.y+N.y*j);
        float minD=M.disTo(R);
        M.showSegmentTo(R);
        for(int k=0;k<nedge&&foundedge==0;k++)
        {
          if(k==i)
            continue;
          if(minD>=edge[k].disToPt(this,R))
          {
            //print("minD:"+minD+","+edge[k].disToPt(this,R)+",k="+k+"\n");
            foundedge=1;
            R.show(2);
            for(float a=.8f;a<3.14f/2;a+=.50f)
            {
              float d=minD*(1-cos(a));
              vec np;
              appendVertex(new pt(M.x+N.x*d,M.y+N.y*d));
              GT[nGT-1].show(1);
              //GT[nGT-1].showLabel(nGT-1);
            }
            appendVertex(R);
            //GT[nGT-1].showLabel(nGT-1);

          }
        }
      }


    }
  }
  float ZERO=.00001f;
  void appendEdge(int s,int e)
  {
    edge[nedge++].make(s,e);
  }
  int CheckDuplicate(int s,int e)// this function removes the hairs if any
  {
    for(int i=0;i<nedge;i++)
    {
      if((edge[i].S==s&&edge[i].E==e)||(edge[i].S==e&&edge[i].E==s))
      {
        stroke(red);
        edge[i].drawEdge(this);
        edge[i].used=1;
        stroke(black);
        return 1;
      }
    }
    return 0;
  }
  int li=-1;
  int Triangluate()// Move the disk from infinity along the normal from the mid point of the edge. As soon as it touches another point we have a triangle
  {
    li++;
    int i=li;// this function is called incrementally from draw(), so there is no explicit loop here. It gives a nice animation of triangulation
    if(i>=nedge)
    {
      li=-1;
      return 0;
    }
    {
      stroke(dgreen);
      //		edge[i].drawEdge(this);
      stroke(black);
      if(edge[i].used==0)
      {
        stroke(red);
        edge[i].drawEdge(this);
        edge[i].used=1;				
        stroke(black);
        pt M=new pt(0,0);
        M.setTo(GT[edge[i].S]);
        M.addPt(GT[edge[i].E]);
        M.scaleBy(.5);
        vec N=GT[edge[i].S].makeVecTo(GT[edge[i].E]);
        N.turnLeft();
        N.scaleBy(-1,-1);
        N.normalize();
        pt O=new pt(0,0);
        float R=-10*GT[edge[i].S].disTo(GT[edge[i].E])/2;// set the inital disk and its radius.
        int tv=-1;
        while(tv==-1)
        {
          O.setTo(M.x+R*N.x,M.y+R*N.y);
          for(int k=0;k<nGT;k++)
          {
            if(k==edge[i].S||k==edge[i].E)
              continue;
            if(dot(M.makeVecTo(GT[k]),N)>ZERO &&GT[k].disTo(O)<=GT[edge[i].S].disTo(O))
            {
              tv=k;
              break;
            }
          }
          R+=.1;
        }

        if(tv!=-1)
        {
          stroke(black);
          if(CheckDuplicate(edge[i].S,tv)==0)
          {
            appendEdge(edge[i].S,tv);
            edge[nedge-1].drawEdge(this);
          }
          if(CheckDuplicate(tv,edge[i].E)==0)
          {
            appendEdge(tv,edge[i].E);							
            edge[nedge-1].drawEdge(this);
          }
          V[nV++]=edge[i].S;
          V[nV++]=edge[i].E;
          V[nV++]=tv;
        }

      }
    }
    return 1;
  }
  boolean contains (pt M) 
  {
    boolean isIn=false; 
    for(int i=1;i<nedge;i++)
    {
      if (M.isInTriangle(GT[edge[0].S],GT[edge[i].S],GT[edge[i].E])) isIn=!isIn;
    }
    return(isIn); 
  }
  float disToclosestEdge(pt M)
  {
    float minD=100000;
    int minDi=-1;
    for(int i=0;i<nedge;i++)
    {	
      float D=edge[i].disToPt(this,M);
      if(minD>D)
      {
        minDi=i;
        minD=D;
      }
    }
    return minD;

  }
  void ballTransform() {
    zmax=400;
    for (int i=0; i<n; i++) for (int j=0; j<n; j++) {
      pt S= new pt(i*h,j*h);
      if (contains(S)) {
        scanSphere(S,disToclosestEdge(S));
      };
    };
  }
  void scanSphere(pt O, float r) {
    float cx=O.x/h, cy=O.y/h, cr=r/h;
    for (int i=max(0,int(cx-cr)); i<min(n,cx+cr); i++) for (int j=max(0,int(cy-cr)); j<min(n,cy+cr); j++) 
      if(sq(cx-i)+sq(cy-j)<sq(cr)) 
      {
        float z=sqrt(sq(cr)-sq(cx-i)-sq(cy-j))*h;    
        if(z>G[i][j].z) G[i][j].z=z;
        zmax=max(zmax,G[i][j].z);
      };
  }

}

