//**************************************
// 3D CAMERA
// Written by Jarek Rossignac,  June 2006 
//*************************************
class cam { 
  float D=10000, sD=D; 
  pt E = new pt(0,0,D); pt sE = new pt(0,0,D);
  pt F = new pt(0,0,0); pt sF = new pt(0,0,0); 
  vec U = new vec(0,1,0);
  vec I = new vec(1,0,0);  vec J = new vec(0,1,0); vec K = new vec(0,0,1);
  int px=0, py=0;

  cam (pt pE, pt pF) {E.setToPoint(pE); F.setToPoint(pF); D=E.disTo(F);};
  
  void apply() { camera(E.x,E.y,E.z,F.x,F.y,F.z,U.x,U.y,U.z);  };
 
  void write() {print("camera:");     println("D="+D); 
    print("E="); E.write(); 
    print("F="); F.write(); 
    print("U="); U.write(); 
    println();};
  
  void anchor() {px=mouseX; py=mouseY; sE.setToPoint(E); sF.setToPoint(F); sD=D;};
  
  void snap() {E.setToPoint(sE); F.setToPoint(sF); D=sD;};  
  void snapD() {D=sD; println(">> snaped D="+D); };  
  
  void pose() {
    vec nK=F.vecTo(E);  
          if (nK.norm()>0.0001) {K.setToVec(nK);} else {println("keep K");}; 
    K.makeUnit(); 
    vec nI=cross(U,K);  
         if (nI.norm()<0.0001) {nI.setToVec(I); println("I=UxJ");}; 
    nI.makeUnit();   
 //   if(dot(I,nI)<0) {nI.back(); println("inverted nI"); U.back(); };
    I.setToVec(nI);
    J.setToVec(cross(K,I)); 
    J.makeUnit(); 
    U.setToVec(J);
    }

  void showPose() {vec II = I.make(); II.mul(100); stroke(250,20,20); II.show(F); vec JJ = U.make(); JJ.mul(100); stroke(0,200,50); JJ.show(F); }
  
  void jump (int c) {
    F.setToPoint(g(c)); 
    vec N = triNormal(t(c)); N.makeUnit();
    E.setToPoint(triCenter(t(c))); 
    vec T = E.vecTo(F); float nT=T.norm(); E.addScaledVec(nT,N);  
    U.setToVec(N); U.back(); sD=6*nT; this.pullE(); this.pose(); 
    println("sD="+sD); this.write(); 
    };
  
  void pullF() {float cD=F.disTo(E);  if (abs(cD)<0.001) {F.setToPoint(E); F.addScaledVec(D,K);} else {F.moveTowards((cD-D)/cD,E);};};
 
  void pullE() {float cD=F.disTo(E);  if (abs(cD)<0.001) {E.setToPoint(F); E.addScaledVec(D,K);} else {E.moveTowards((cD-D)/cD,F);};};
 
  void recomputeD() {D=E.disTo(F);};
 
  void fly(float s) {
    float r=width*2; float x=(mouseX-width/2)/r;   float y=(mouseY-height/2)/r; 
    F.addScaledVec(x,I); F.addScaledVec(y,J); F.addScaledVec(-s,K);
    };
    
  void Turn() {
    float r=width/D/4; float x=-(mouseX-width/2)/r;   float y=-(mouseY-height/2)/r; 
    F.addScaledVec(x,I); F.addScaledVec(y,J); 
    if (cross(U,F.vecTo(E)).norm()<0.1) { F.addScaledVec(-x/10.0,I); F.addScaledVec(-y/10.0,J); };
    };
    
  void turn() {
    float r=float(width)/D; r=100; float x=-(mouseX-px)/r; float y=-(mouseY-py)/r; 
    F.setToPoint(sF); F.addScaledVec(x,I); F.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1) { F.addScaledVec(-x/10.0,I); F.addScaledVec(-y/10.0,J); };
    };
    
  void Pan() {
    float r=16*width/D; float x=-(mouseX-width/2)/r;   float y=-(mouseY-height/2)/r; 
    E.addScaledVec(x,I); E.addScaledVec(y,J);   
    if (cross(U,F.vecTo(E)).norm()<0.1) { F.addScaledVec(-x/10.0,I); F.addScaledVec(-y/10.0,J); };
    };
    
  void pan() {
    float r=width/D/2; float x=-(mouseX-px)/r;   float y=-(mouseY-py)/r;     
    E.setToPoint(sE); E.addScaledVec(x,I); E.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1) { F.addScaledVec(-x/10.0,I); F.addScaledVec(-y/10.0,J); };
    };

  void zoom() {
    float r=width/Rbox/2; float x=-(mouseX-px)/r;   float y=-(mouseY-py)/r; 
    E.setToPoint(sE); E.addScaledVec(x,I); 
    D=sD+y*sD/height; 
    };
   
  void track (cam K) {float s=0.0005*nt; if (s<0.005) {s=0.005;}; if (s>0.25) {s=0.25;}; E.moveTowards(s,K.E); F.moveTowards(s,K.F); this.recomputeD(); U.addScaled(s,K.U); U.makeUnit(); this.pose(); this.anchor();}
  void setToCam (cam K) {E.setToPoint(K.E); F.setToPoint(K.F); this.recomputeD(); U.setToVec(K.U); U.makeUnit(); this.pose(); this.anchor();}
 }
