import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class meshes extends PApplet {//**********************************
//***   tools for rendering T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
public void shade(int i) { beginShape(TRIANGLES); G[V[3*i]].vert(); G[V[3*i+1]].vert(); G[V[3*i+2]].vert(); endShape(); }; // shade tris

public void showBorder() {for (int i=0; i<nc; i++) {if (border(i)) {drawEdge(i);}; }; };         // draws all border edges
 
public pt triCenter(int i) {return(triCenterFromPts( G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]] )); };  // computes center of triangle t(i) 

public vec triNormal(int i) { return(triNormalFromPts(G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]])); };  // computes triangle t(i) normal * area / 2

public void computeTriNormals() {for (int i=0; i<nt; i++) {Nt[i]= triNormal(i); };};             // caches normals of all tirangles

public void showTriNormals() {vec N= new vec(0,0,0);                                             // renders tirangle normals with length 20
  for (int i=0; i<nt; i++) {N.setToVec(Nt[i]); N.makeUnit(); N.mul(20); N.show(triCenter(i)); };
  for (int i=0; i<nv; i++) {N.setToVec(Nv[i]); N.div(10); N.show(G[i]); };
  };

public void writeTri (int i) {println("T"+i+": V = ("+V[3*i]+","+V[3*i+1]+","+V[3*i+2]+"), O = ("+O[3*i]+","+O[3*i+1]+","+O[3*i+2]+")"); };

public void computeBox() {
  pt Lbox =  G[0].make();  pt Hbox =  G[0].make();
  for (int i=1; i<nv; i++) { 
    Lbox.x=min(Lbox.x,G[i].x); Lbox.y=min(Lbox.y,G[i].y); Lbox.z=min(Lbox.z,G[i].z);
    Hbox.x=max(Hbox.x,G[i].x); Hbox.y=max(Hbox.y,G[i].y); Hbox.z=max(Hbox.z,G[i].z); 
    };
  Cbox.setToPoint(midPt(Lbox,Hbox));  Rbox=Cbox.disTo(Hbox);
  println("Box r="+Rbox); print("C="); Cbox.write(); print("L="); Lbox.write(); print("H="); Hbox.write();
  };

//**************************************
// 3D CAMERA
// Written by Jarek Rossignac,  June 2006 
//*************************************
class cam { 
  float D=10000, sD=D; 
  pt E = new pt(0,0,D); pt sE = new pt(0,0,D);
  pt F = new pt(0,0,0); pt sF = new pt(0,0,0); 
  vec U = new vec(0,1,0);
  vec I = new vec(1,0,0);  vec J = new vec(0,1,0); vec K = new vec(0,0,1);
  int px=0, py=0;

  cam (pt pE, pt pF) {E.setToPoint(pE); F.setToPoint(pF); D=E.disTo(F);};
  
  public void apply() { camera(E.x,E.y,E.z,F.x,F.y,F.z,U.x,U.y,U.z);  };
 
  public void write() {print("camera:");     println("D="+D); 
    print("E="); E.write(); 
    print("F="); F.write(); 
    print("U="); U.write(); 
    println();};
  
  public void anchor() {px=mouseX; py=mouseY; sE.setToPoint(E); sF.setToPoint(F); sD=D;};
  
  public void snap() {E.setToPoint(sE); F.setToPoint(sF); D=sD;};  
  public void snapD() {D=sD; println(">> snaped D="+D); };  
  
  public void pose() {
    vec nK=F.vecTo(E);  
          if (nK.norm()>0.0001f) {K.setToVec(nK);} else {println("keep K");}; 
    K.makeUnit(); 
    vec nI=cross(U,K);  
         if (nI.norm()<0.0001f) {nI.setToVec(I); println("I=UxJ");}; 
    nI.makeUnit();   
 //   if(dot(I,nI)<0) {nI.back(); println("inverted nI"); U.back(); };
    I.setToVec(nI);
    J.setToVec(cross(K,I)); 
    J.makeUnit(); 
    U.setToVec(J);
    }

  public void showPose() {vec II = I.make(); II.mul(100); stroke(250,20,20); II.show(F); vec JJ = U.make(); JJ.mul(100); stroke(0,200,50); JJ.show(F); }
  
  public void jump (int c) {
    F.setToPoint(g(c)); 
    vec N = triNormal(t(c)); N.makeUnit();
    E.setToPoint(triCenter(t(c))); 
    vec T = E.vecTo(F); float nT=T.norm(); E.addScaledVec(nT,N);  
    U.setToVec(N); U.back(); sD=6*nT; this.pullE(); this.pose(); 
    println("sD="+sD); this.write(); 
    };
  
  public void pullF() {float cD=F.disTo(E);  if (abs(cD)<0.001f) {F.setToPoint(E); F.addScaledVec(D,K);} else {F.moveTowards((cD-D)/cD,E);};};
 
  public void pullE() {float cD=F.disTo(E);  if (abs(cD)<0.001f) {E.setToPoint(F); E.addScaledVec(D,K);} else {E.moveTowards((cD-D)/cD,F);};};
 
  public void recomputeD() {D=E.disTo(F);};
 
  public void fly(float s) {
    float r=width*2; float x=(mouseX-width/2)/r;   float y=(mouseY-height/2)/r; 
    F.addScaledVec(x,I); F.addScaledVec(y,J); F.addScaledVec(-s,K);
    };
    
  public void Turn() {
    float r=width/D/4; float x=-(mouseX-width/2)/r;   float y=-(mouseY-height/2)/r; 
    F.addScaledVec(x,I); F.addScaledVec(y,J); 
    if (cross(U,F.vecTo(E)).norm()<0.1f) { F.addScaledVec(-x/10.0f,I); F.addScaledVec(-y/10.0f,J); };
    };
    
  public void turn() {
    float r=PApplet.parseFloat(width)/D; r=100; float x=-(mouseX-px)/r; float y=-(mouseY-py)/r; 
    F.setToPoint(sF); F.addScaledVec(x,I); F.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1f) { F.addScaledVec(-x/10.0f,I); F.addScaledVec(-y/10.0f,J); };
    };
    
  public void Pan() {
    float r=16*width/D; float x=-(mouseX-width/2)/r;   float y=-(mouseY-height/2)/r; 
    E.addScaledVec(x,I); E.addScaledVec(y,J);   
    if (cross(U,F.vecTo(E)).norm()<0.1f) { F.addScaledVec(-x/10.0f,I); F.addScaledVec(-y/10.0f,J); };
    };
    
  public void pan() {
    float r=width/D/2; float x=-(mouseX-px)/r;   float y=-(mouseY-py)/r;     
    E.setToPoint(sE); E.addScaledVec(x,I); E.addScaledVec(y,J);  
    if (cross(U,F.vecTo(E)).norm()<0.1f) { F.addScaledVec(-x/10.0f,I); F.addScaledVec(-y/10.0f,J); };
    };

  public void zoom() {
    float r=width/Rbox/2; float x=-(mouseX-px)/r;   float y=-(mouseY-py)/r; 
    E.setToPoint(sE); E.addScaledVec(x,I); 
    D=sD+y*sD/height; 
    };
   
  public void track (cam K) {float s=0.0005f*nt; if (s<0.005f) {s=0.005f;}; if (s>0.25f) {s=0.25f;}; E.moveTowards(s,K.E); F.moveTowards(s,K.F); this.recomputeD(); U.addScaled(s,K.U); U.makeUnit(); this.pose(); this.anchor();}
  public void setToCam (cam K) {E.setToPoint(K.E); F.setToPoint(K.F); this.recomputeD(); U.setToVec(K.U); U.makeUnit(); this.pose(); this.anchor();}
 }

//**********************************
//***      corners tools
// Written by Jarek Rossignac,  June 2006 
//**********************************
    
public int t (int c) {int r=PApplet.parseInt(c/3); return(r);};
public int n (int c) {int r=3*PApplet.parseInt(c/3)+(c+1)%3; return(r);};
public int p (int c) {int r=3*PApplet.parseInt(c/3)+(c+2)%3; return(r);};
public int v (int c) {return(V[c]);};
public int o (int c) {return(O[c]);};
public int l (int c) {return(o(n(c)));};
public int r (int c) {return(o(p(c)));};
public int w (int c) {return(W[c]);};               // temporary indices to mid-edge vertices associated with corners during subdivision
public boolean border (int c) {return(O[c]==-1);};  // returns true if corner has no opposite
public boolean nb(int c) {return(O[c]!=-1);};
public pt g (int c) {return(G[V[c]]);};             // shortcut to get the point of the vertex v(c) of corner c

public pt cg(int c) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  return(cPt); };   // computes point at corner
public void showCorner(int c) {pt cPt = midPt(g(c),midPt(g(c),triCenter(t(c))));  cPt.show(3); };   // renders corner c as small ball
public void drawEdge(int c) {line(g(p(c)).x,g(p(c)).y,g(p(c)).z,g(n(c)).x,g(n(c)).y,g(n(c)).z); };  // draws edge of t(c) opposite to corner c

public void computeO() {                         // sets the O table from the V table, assumes consistent orientation of tirangles
  for (int i=0; i<3*nt; i++) {O[i]=-1;};  // init O table to -1: has no opposite (i.e. is a border corner)
  for (int i=0; i<3*nt; i++) {  for (int j=i+1; j<3*nt; j++) {       // for each corner i, for each other corner j
      if( (v(n(i))==v(p(j))) && (v(p(i))==v(n(j))) ) {O[i]=j; O[j]=i;};};}; // make i and j opposite if they match         
  };

//**********************************
//***      distances
// Written by Jarek Rossignac,  June 2006 
//**********************************
int maxr=3;
public void computeDistance(int maxr) {
  int tc=0;
  int r=1;
  for(int i=0; i<nt; i++) {Mt[i]=0;};  Mt[t(c)]=1; tc++;
  for(int i=0; i<nv; i++) {Mv[i]=0;};
  while ((tc<nt)&&(r<=maxr)) {
      for(int i=0; i<nc; i++) {if ((Mv[v(i)]==0)&&(Mt[t(i)]==r)) {Mv[v(i)]=r;};};
     for(int i=0; i<nc; i++) {if ((Mt[t(i)]==0)&&(Mv[v(i)]==r)) {Mt[t(i)]=r+1; tc++;};};
     r++;
     };
  rings=r;
  }
  
public void computeIsolation() {
  println("Starting isolation computation for "+nt+" triangles");
  for(int i=0; i<nt; i++) {SMt[i]=0;}; 
  for(c=0; c<nc; c+=3) {println("  triangle "+t(c)+"/"+nt); computeDistance(1000); for(int j=0; j<nt; j++) {SMt[j]+=Mt[j];}; };
  int L=SMt[0], H=SMt[0];  for(int i=0; i<nt; i++) { H=max(H,SMt[i]); L=min(L,SMt[i]);}; if (H==L) {H++;};
  c=0; for(int i=0; i<nt; i++) {Mt[i]=(SMt[i]-L)*255/(H-L); if(Mt[i]>Mt[t(c)]) {c=3*i;};}; rings=255;
  for(int i=0; i<nv; i++) {Mv[i]=0;};  for(int i=0; i<nc; i++) {Mv[v(i)]=max(Mv[v(i)],Mt[t(i)]);};
  println("finished isolation");
  }
  
public void computePath() {
  for(int i=0; i<nt; i++) {Mt[i]=0;}; Mt[0]=1; 
  for(int i=0; i<nc; i++) {P[i]=false;};
  int r=1;
  boolean searching=true;
  while (searching) {
     for(int i=0; i<nc; i++) {
       if (searching&&(Mt[t(i)]==0)&&(o(i)!=-1)) {
         if(Mt[t(o(i))]==r) {
           Mt[t(i)]=r+1; 
           P[i]=true; 
           if(t(i)==t(c)){searching=false;};
           };
         };
       };
     r++;
     };
  for(int i=0; i<nt; i++) {Mt[i]=0;};
  rings=1;
  while (t(c)!=0) {rings++;
    if (P[c]) {c=o(c); print(".o");} else {if (P[p(c)]) {c=r(c);print(".r");} else {c=l(c);print(".l");};}; Mt[t(c)]=rings;};
  }

//**********************************
//***   tools for archiving T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************

public void saveMesh() {
  String [] inppts = new String [nv+1+nt+1];
  int s=0;
  inppts[s++]=str(nv);
  for (int i=0; i<nv; i++) {inppts[s++]=str(G[i].x)+","+str(G[i].y)+","+str(G[i].z);};
  inppts[s++]=str(nt);
  if (flipOrientation) {for (int i=0; i<nt; i++) {inppts[s++]=str(V[3*i])+","+str(V[3*i+2])+","+str(V[3*i+1]);};}
    else {for (int i=0; i<nt; i++) {inppts[s++]=str(V[3*i])+","+str(V[3*i+1])+","+str(V[3*i+2]);};};
  saveStrings("mesh.vts",inppts);  println("saved");
  };

public void loadMesh() {
  String [] ss = loadStrings(fn[fni]);
  String subpts;
  int s=0;   int comma1, comma2;   float x, y, z;   int a, b, c;
  nv = PApplet.parseInt(ss[s++]);
    println("nv="+nv);
    for(int k=0; k<nv; k++) {int i=k+s; 
      comma1=ss[i].indexOf(',');   
      x=PApplet.parseFloat(ss[i].substring(0, comma1));
      String rest = ss[i].substring(comma1+1, ss[i].length());
      comma2=rest.indexOf(',');    y=PApplet.parseFloat(rest.substring(0, comma2)); z=PApplet.parseFloat(rest.substring(comma2+1, rest.length()));
      G[k].setTo(x,y,z);
    };
  s=nv+1;
  nt = PApplet.parseInt(ss[s]); nc=3*nt;
  println("nt="+nt);
  s++;
  for(int k=0; k<nt; k++) {int i=k+s;
      comma1=ss[i].indexOf(',');   a=PApplet.parseInt(ss[i].substring(0, comma1));  
      String rest = ss[i].substring(comma1+1, ss[i].length()); comma2=rest.indexOf(',');  
      b=PApplet.parseInt(rest.substring(0, comma2)); c=PApplet.parseInt(rest.substring(comma2+1, rest.length()));
      V[3*k]=a;  V[3*k+1]=b;  V[3*k+2]=c;
    }
  };
  

//*** GLOBAL VARIABLES ***
// Written by Jarek Rossignac,  June 2006 
                 
// CAMERA
pt Origin=new pt(0,0,0);
pt Eye=new pt(0,0,800);
cam C = new cam(Eye, Origin);
cam C1 = new cam(Eye, Origin);
cam C2 = new cam(Eye, Origin);
float svd=800;
//float fov=atan2(width/2,svd);
float fov=PI/3;
pt Cbox = new pt(width/2,height/2,0);                   // mini-max box center
float Rbox=1000;    

// CAMERA
pt Mouse = new pt(0,0,0);                 // current mouse position
float xr, yr = 0;                         // mouse coordinates relative to center of window
int px=0, py=0;                           // coordinats of mouse when it was last pressed

// DISPLAY
vec labelD=new vec(-10,-10, 2);           // offset vector for drawing labels
boolean showNormals=false, showVertices=false, showEdges=true, showLabels=false, showPath=false;  // flags for rendering
boolean jumps=true;
int grey = color(200, 200, 210), red = color(200, 10, 10), blue = color(10, 10, 200), lightblue = color(100, 100, 255),
      green = color(10, 200, 20), black = color(10, 10, 10), magenta = color(250, 150, 200), brown = color(150, 100, 50), 
      yellow = color(255, 238, 70); 
      
// FILES      
String [] fn= new String[4];
int fni=0;   

// VERTICES
int w=4;                                   // size of initial Tmesh-grid made in setup
int nv = w*w, maxnv = 10000;;               // current and max number of vertices
pt[] G = new pt [maxnv];                   // geometry table (vertices)
vec[] Nv = new vec [maxnv];                // vertex normals or laplace vectors
int [] valence = new int [maxnv];          // vertex valence (count of incident triangles)
int[] Mv = new int[maxnv];                    // vertex markers

// TRIANGLES
int nt = 2*(w-1)*(w-1), maxnt = maxnv*2;   // current and max number of triangles
vec[] Nt = new vec [maxnt];                // vtriangles normals
int[] Mt = new int[maxnt];                 // triangle markers for distance and other things   
int[] SMt = new int[maxnt];                // sum of triangle markers for isolation
boolean flipOrientation=false;            // if set, save will flip all triangles
int rings=1;                               // number of rings for colorcoding

// CORNERS
int nc = nt*3;                             // current number of corners (3 per triangle)
int[] V = new int [3*maxnt];               // V table (triangle/vertex indices)
int[] O = new int [3*maxnt];               // O table (opposite corner indices)
int[] W = new int [3*maxnt];               // mid-edge vertex indices for subdivision (associated with corner opposite to edge)
int c = 0;                                 // current corner shown in image and manipulated with keys: n, p, o, l, r
boolean[] P = new boolean [3*maxnt];  

//**********************************
//***     simlification utilities
// Written by Jarek Rossignac,  June 2006 
//********************************** 
    
public void flip(int c) {      // fip edge opposite to corner c
    V[n(o(c))]=v(c); V[n(c)]=v(o(c));
    int co=o(c); O[co]=r(c); O[r(c)]=co; O[c]=r(co); O[r(co)]=c; O[p(c)]=p(co); O[p(co)]=p(c);
  }
  
public void doFlips() {  for (int c=0; c<3*nt; c++) {if (g(n(c)).disTo(g(p(c)))>g(c).disTo(g(o(c)))) {flip(c);}; };  } // assumes manifold

public void collapse(int c) {      // collapse edge opposite to corner c
    int b=p(c), oc=o(c), vnc=v(n(c));
    for (int a=b; a!=n(oc); a=p(r(a))) {V[a]=vnc;}; V[p(c)]=vnc; V[n(oc)]=vnc; 
    O[l(c)]=r(c); O[r(c)]=l(c);     O[l(oc)]=r(oc); O[r(oc)]=l(oc); 
  }

//**********************************
//***      skeleton
// Written by Jarek Rossignac,  June 2006 
//**********************************
public void computeSkeleton() {
  int tc=0;
  int r=1;
  for(int i=0; i<nt; i++) {Mt[i]=0;};  
  for(int i=0; i<nv; i++) {Mv[i]=0; if (valence[i]!=6) {Mv[i]=1;};};
  for(int i=0; i<nc; i++) {if ((Mt[t(i)]==0)&&(Mv[v(i)]==r)) {Mt[t(i)]=1; tc++;};};
  for(int i=0; i<nc; i++) {
     if (Mt[t(i)]==0) {
         int nbrs=0; 
         if((o(i)!=-1)&&(Mt[t(o(i))]==1)) {nbrs++;};
         if((r(i)!=-1)&&(Mt[t(r(i))]==1)) {nbrs++;};
         if((l(i)!=-1)&&(Mt[t(l(i))]==1)) {nbrs++;};
         if (nbrs>2) {Mt[t(i)]=1;};
         };
     };
    for(int i=0; i<nv; i++) {Mv[i]=0;};

/*  while (tc<nt) {
      for(int i=0; i<nc; i++) {if ((Mv[v(i)]==0)&&(Mt[t(i)]==r)) {Mv[v(i)]=r;};};
     for(int i=0; i<nc; i++) {if ((Mt[t(i)]==0)&&(Mv[v(i)]==r)) {Mt[t(i)]=r+1; tc++;};};
     r++;
     };
     /**/
  rings=r;
  }

//**********************************
//***      smoothing T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
public void computeValence() {      // caches valence of each vertex
  for (int i=0; i<nv; i++) {Nv[i].setTo(0,0,0); valence[i]=0;};  // resets the valences to 0
  for (int i=0; i<3*nt; i++) {valence[v(i)]++; };
  }
  
public void computeVertexNormals() {  // computes the vertex normals as sums of the normal vectors of incident tirangles scaled by area/2
  computeValence();
  for (int i=0; i<3*nt; i++) {Nv[v(p(i))].add(g(p(i)).vecTo(g(n(i))));};
  for (int i=0; i<nv; i++) {Nv[i].div(valence[i]);}; 
  };
  
public void tuck(float s) {for (int i=0; i<nv; i++) {G[i].addScaledVec(s,Nv[i]);}; };  // displaces each vertex by a fraction s of its normal

//**********************************
//***      subdivision for T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
public void splitEdges() {            // creates a new vertex for each edge and stores its ID in the W of the corner (and of its opposite if any)
  for (int i=0; i<3*nt; i++) {  // for each corner i
    if(border(i)) {G[nv]=midPt(g(n(i)),g(p(i))); W[i]=nv++;}
    else {if(i<o(i)) {G[nv]=midPt(g(n(i)),g(p(i))); W[o(i)]=nv; W[i]=nv++; }; };  // if this corner is the first to see the edge
    };
  };
  
public void bulge() {              // tweaks the new mid-edge vertices according to the Butterfly mask
  for (int i=0; i<3*nt; i++) {
    if((!border(i))&&(i<o(i))) {    // no tweak for mid-vertices of border edges
     G[W[i]].addScaledVec(0.25f,midPt(midPt(g(l(i)),g(r(i))),midPt(g(l(o(i))),g(r(o(i))))).vecTo(midPt(g(i),g(o(i))))); 
      }; 
    };
  };
  
public void splitTriangles() {    // splits each tirangle into 4
  for (int i=0; i<3*nt; i=i+3) {
    V[3*nt+i]=v(i); V[n(3*nt+i)]=w(p(i)); V[p(3*nt+i)]=w(n(i));
    V[6*nt+i]=v(n(i)); V[n(6*nt+i)]=w(i); V[p(6*nt+i)]=w(p(i));
    V[9*nt+i]=v(p(i)); V[n(9*nt+i)]=w(n(i)); V[p(9*nt+i)]=w(i);
    V[i]=w(i); V[n(i)]=w(n(i)); V[p(i)]=w(p(i));
    };
  nt=4*nt; nc=3*nt;
  };

//**************************************
// 3D POINTS AND VECTOR CLASSES
// Written by Jarek Rossignac,  June 2006
//*************************************
class pt { float x,y,z; 
  pt (float px, float py, float pz) {x = px; y = py; z = pz;};
  public pt make() {return(new pt(x,y,z));};
  public void show(int r) { pushMatrix(); translate(x,y,z); sphere(r); popMatrix();}; 
  public void showLineTo (pt P) {line(x,y,z,P.x,P.y,P.z); }; 
  public void setToPoint(pt P) { x = P.x; y = P.y; z = P.z;}; 
  public void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public void setToMouse() { x = mouseX; y = mouseY; }; 
  public void write() {println("("+x+","+y+","+z+")");};
  public void addVec(vec V) {x += V.x; y += V.y; z += V.z;};
  public void addScaledVec(float s, vec V) {x += s*V.x; y += s*V.y; z += s*V.z;};
  public void moveTowards(float s, pt P) {x += s*(P.x-x); y += s*(P.y-y); z += s*(P.z-z);};
  public void subVec(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  public void vert() {vertex(x,y,z);};
  public void vertext(float u, float v) {vertex(x,y,z,u,v);};
  public boolean isInWindow() {return(((x<0)||(x>width)||(y<0)||(y>height)));};
  public void label(String s, vec D) {text(s, x+D.x, y+D.y, z+D.z);  };
  public vec vecTo(pt P) {return(new vec(P.x-x,P.y-y,P.z-z)); };
  public float disTo(pt P) {return(sqrt( sq(P.x-x)+sq(P.y-y)+sq(P.z-z) )); };
  public vec vecToMid(pt P, pt Q) {return(new vec((P.x+Q.x)/2.0f-x,(P.y+Q.y)/2.0f-y,(P.z+Q.z)/2.0f-z )); };
  public vec vecToProp (pt B, pt D) {
      vec CB = this.vecTo(B); float LCB = CB.norm();
      vec CD = this.vecTo(D); float LCD = CD.norm();
      vec U = CB.make();
      vec V = CD.make(); V.sub(U); V.mul(LCB/(LCB+LCD));
      U.add(V);
      return(U);  
      };  
  public void addPt(pt P) {x+=P.x; y+=P.y; z+=P.z;};
  public void subPt(pt P) {x-=P.x; y-=P.y; z-=P.z; };
  public void mul(float f) {x*=f; y*=f; y*=f;};
  public void pers(float d) { y=d*y/(d+z); x=d*x/(d+z); z=d*z/(d+z); };
  public void inverserPers(float d) { y=d*y/(d-z); x=d*x/(d-z); z=d*z/(d-z); };
  public boolean coplanar (pt A, pt B, pt C) {return(abs(tetVol(this,A,B,C))<0.0001f);};
  public boolean cw (pt A, pt B, pt C) {return(tetVol(this,A,B,C)>0.0001f);};
  } ;
 
class vec { float x,y,z; 
  vec (float px, float py, float pz) {x = px; y = py; z = pz;};
  public void setTo (float px, float py, float pz) {x = px; y = py; z = pz;}; 
  public vec make() {return(new vec(x,y,z));};
  public void setToVec(vec V) { x = V.x; y = V.y; z = V.z;}; 
  public void show (pt P) {line(P.x,P.y, P.z,P.x+x,P.y+y,P.z+z); }; 
  public void add(vec V) {x += V.x; y += V.y; z += V.z;};
  public void addScaled(float m, vec V) {x += m*V.x; y += m*V.y; z += m*V.z;};
  public void sub(vec V) {x -= V.x; y -= V.y; z -= V.z;};
  public void mul(float m) {x *= m; y *= m; z *= m;};
  public void div(float m) {x /= m; y /= m; z /= m;};
  public void write() {println("("+x+","+y+","+z+")");};
  public float norm() {return(sqrt(sq(x)+sq(y)+sq(z)));}; 
  public void makeUnit() {float n=this.norm(); if (n>0.0001f) {this.div(n);};};
  public void back() {x= -x; y= -y; z= -z;};
  public boolean coplanar (vec V, vec W) {return(abs(mixed(this,V,W))<0.0001f);};
  public boolean cw (vec U, vec V, vec W) {return(mixed(this,V,W)>0.0001f);};
  } ;
  
public vec triNormalFromPts(pt A, pt B, pt C) {vec N = cross(A.vecTo(B),A.vecTo(C));  return(N); };
public float tetVol (pt A, pt B, pt C, pt D) { return(dot(triNormalFromPts(A,B,C),A.vecTo(D))); };
public vec midVec(vec U, vec V) {return(new vec((U.x+V.x)/2,(U.y+V.y)/2,(U.z+V.z)/2)); };
public float dot(vec U, vec V) {return(U.x*V.x+U.y*V.y+U.z*V.z); };
public vec cross(vec U, vec V) {return(new vec( U.y*V.z-U.z*V.y, U.z*V.x-U.x*V.z, U.x*V.y-U.y*V.x )); };
public float mixed(vec U, vec V, vec W) {return(dot(cross(U,V),W)); };
public pt midPt(pt A, pt B) {return(new pt((A.x+B.x)/2 , (A.y+B.y)/2, (A.z+B.z)/2 )); };
public pt triCenterFromPts(pt A, pt B, pt C) {return(new pt((A.x+B.x+C.x)/3 , (A.y+B.y+C.y)/3, (A.z+B.z+C.z)/3 )); };





// Triangle mesh viewer + corner table + subdivision + smoothing
// Written by Jarek Rossignac June 2006
//import processing.opengl.*;  // uncomment for OpenGL


// ** SETUP **
public void setup() { 
  size(600, 600, P3D);        //for OpenGL use: 
//   size(800, 800, OPENGL);  
  PFont font = loadFont("Courier-14.vlw"); textFont(font, 12);  // font for writing labels on screen
  for (int i=0; i<maxnv; i++) {G[i]=new pt(0,0,0); Nv[i]=new vec(0,0,0);};   // init vertices and normals
  for (int i=0; i<maxnt; i++) {Nt[i]=new vec(0,0,0);};                        // init triangler normals
  for (int i=0; i<w; i++) {for (int j=0; j<w; j++) {                          // make a 2D grid of vertices
    G[w*i+j].setTo(width*.8f*j/(w-1)+width/10,height*.8f*i/(w-1)+height/10,0);}}    
  for (int i=0; i<w-1; i++) {for (int j=0; j<w-1; j++) {                  // define the triangles for the grid
      V[(i*(w-1)+j)*6]=i*w+j;       V[(i*(w-1)+j)*6+2]=(i+1)*w+j;       V[(i*(w-1)+j)*6+1]=(i+1)*w+j+1;
      V[(i*(w-1)+j)*6+3]=i*w+j;     V[(i*(w-1)+j)*6+5]=(i+1)*w+j+1;     V[(i*(w-1)+j)*6+4]=i*w+j+1;    }; };
  computeBox();  C.F.setToPoint(Cbox); C.pullE(); 
  computeO();                                                  // compute the box and the O table
  fn[0]="mesh.vts"; fn[1]="mesh.vts"; fn[2]="mesh.vts"; fn[3]="mesh.vts";
  } 
 
// ** DRAW **
public void draw() {
  int r=PApplet.parseInt(6*Rbox/width);
  background(255); 
  lights(); directionalLight(128,128,128,0,1,0); directionalLight(128,128,128,0,0,1);
  sphereDetail(4); 
  translate(PApplet.parseFloat(width)/2, PApplet.parseFloat(height)/2, 0.0f);     // center view wrt window  
  if ((!keyPressed)&&(mousePressed)) {C.pan(); C.pullE(); };
  if ((keyPressed)&&(mousePressed)) {updateView();}; 
  perspective(PI/3.0f,width/height,1.0f,6.0f*Rbox); 
  C1.track(C); C2.track(C1);  C2.apply();                              
   if (showEdges) {stroke(black);} else {noStroke();}; for(int i=0; i<nt; i++) {int col=Mt[i]*255/rings; fill(col,255-col,10); shade(i); };
  if (showVertices) {noStroke(); for (int i=0; i<nv; i++) {
    if (Mv[i]==0) {if (valence[i]==6) {fill(yellow);} else {fill(blue);}; }
     else {int col=255-Mv[i]*255/rings; fill(col,col,col); } G[i].show(r); };};
  if (showLabels) { fill(black); for (int i=0; i<nv; i++) {G[i].label(str(i),labelD); }; };
  if (showNormals) {stroke(blue); showTriNormals();};                // show triangle normals
  noStroke(); fill(100); shade(t(c)); fill(150); showCorner(c);   // show current corner c in blue and paint its triangle green
  stroke(red); showBorder();                                          // show border edges in red  
//    fill(50); noStroke(); C.F.show(r);  stroke(100,255,100); C.showPose();
  }
  
//***      KEY ACTIONS
public void keyPressed() {  
  if (key=='a') {flipOrientation=!flipOrientation; print("Will "); if(flipOrientation) {print("not ");}; println("orientation");};  
  if (key=='c') {collapse(c); c=l(c);}; 
  if (key=='f') {flip(c); }; 
  if (key=='g') {fni=(fni+1)%4; println("Will read model "+fn[fni]);};
  if (key=='h') {C.F.setToPoint(Cbox); C.D=Rbox*2; C.U.setTo(0,1,0); C.E.setToPoint(C.F); C.E.addVec(new vec(0,0,1)); C.pullE(); C.pose();};
  if (key=='j') {C.jump(c); C.snapD(); C.pullE();}
  if (key=='l') {println("l("+c+")="+l(c)); if(l(c)!=-1) {c=l(c);}; if (jumps) {C.jump(c);};};
  if (key=='n') {println("n("+c+")="+n(c)); c=n(c);};  
  if (key=='o') {println("o("+c+")="+o(c)); if(o(c)!=-1) {c=o(c);}; if (jumps) {C.jump(c);}; };  
  if (key=='p') {println("p("+c+")="+p(c)); c=p(c);};  
  if (key=='r') {println("r("+c+")="+r(c)); if(r(c)!=-1) {c=r(c);}; if (jumps) {C.jump(c);};}; 
  if (key=='t') {println("t("+c+")="+t(c));};  
  if (key=='u') {C.U.setTo(0,1,0);};
  if (key=='+') {maxr++;};
  if (key=='-') {maxr--; if (maxr<1) {maxr=1;};};
  if (keyCode==LEFT) {left(); right(); left(); if (jumps) {C.jump(c);};};
  if (keyCode==RIGHT) {right(); left(); right(); if (jumps) {C.jump(c);};};
  if (keyCode==DOWN) {back();left(); right(); right(); left();back(); if (jumps) {C.jump(c);}; };
  if (keyCode==UP) {left(); right(); right(); left(); if (jumps) {C.jump(c);};};
  if (key=='A') {saveMesh(); };  
  if (key=='B') {print("Subdividing..."); splitEdges(); bulge(); splitTriangles(); computeO(); computeValence(); computeTriNormals(); println("done");}; // Butterfly 
  if (key=='C') {computeValence(); computeSkeleton(); }; 
  if (key=='D') {computeDistance(maxr); }; 
  if (key=='E') {showEdges=!showEdges; };  
  if (key=='F') {doFlips(); }; 
  if (key=='G') {loadMesh();  computeBox();  computeO(); computeTriNormals(); computeVertexNormals();};  
  if (key=='I') {computeIsolation();}; 
  if (key=='J') {jumps=!jumps; }; 
  if (key=='L') {showLabels=!showLabels; };  
  if (key=='N') {showNormals=!showNormals; };  
  if (key=='O') {computeO();};  
  if (key=='P') {if (showPath) {showPath=false;} else {computePath(); showPath=true;};};  
  if (key=='R') {print("Refining..."); splitEdges(); splitTriangles(); computeO(); computeValence(); computeTriNormals(); println("done");};   // refine mesh in place
  if (key=='S') {computeVertexNormals(); tuck(0.6f); computeVertexNormals(); tuck(-0.6f);   };  // bi-laplace smoothing
  if (key=='T') {computeVertexNormals(); tuck(0.1f); };  
  if (key=='U') {computeVertexNormals(); tuck(-0.1f); };  
  if (key=='V') {showVertices=!showVertices; };  
  if (key=='W') {println(nv+" vertices:"); for (int i=0; i<nv; i++) { print("V"+i+" = "); G[i].write();}; println(nt+" triangles:"); for (int i=0; i<nt; i++) { writeTri(i);}; };  
  };
  
public void mousePressed() {C.anchor(); C.pose();  };       // record where the cursor was when the mouse was pressed
public void mouseReleased() {C.anchor(); C.pose(); };  // reset the view if any key was pressed when mouse was released 

public void updateView() {
  if (keyCode==SHIFT) {C.Pan(); C.pullE(); };
  if (key==' ') {C.pose(); C.Pan(); C.pullE(); };
  if (key=='z') {C.pose(); C.zoom(); C.pullE(); };
  if (key=='1') {C.pose(); C.fly(1.0f); C.pullE(); };  if (key=='2') {C.pose(); C.fly(-1.0f); C.pullE();  };
  if (key=='3') {C.turn(); C.pullE(); };  if (key=='4') {C.pose(); C.Turn(); C.pullE(); };
  if (key=='5') {C.pan(); C.pullE(); }; 
  }

public void left() {if(l(c)!=-1) {c=l(c);};};
public void right() {if(r(c)!=-1) {c=r(c);};};
public void back() {if(o(c)!=-1) {c=o(c);};};

  






  static public void main(String args[]) {     PApplet.main(new String[] { "meshes" });  }}