//**********************************
//***   tools for rendering T-meshes
// Written by Jarek Rossignac,  June 2006 
//**********************************
void shade(int i) { beginShape(TRIANGLES); G[V[3*i]].vert(); G[V[3*i+1]].vert(); G[V[3*i+2]].vert(); endShape(); }; // shade tris

void showBorder() {for (int i=0; i<nc; i++) {if (border(i)) {drawEdge(i);}; }; };         // draws all border edges
 
pt triCenter(int i) {return(triCenterFromPts( G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]] )); };  // computes center of triangle t(i) 

vec triNormal(int i) { return(triNormalFromPts(G[V[3*i]], G[V[3*i+1]], G[V[3*i+2]])); };  // computes triangle t(i) normal * area / 2

void computeTriNormals() {for (int i=0; i<nt; i++) {Nt[i]= triNormal(i); };};             // caches normals of all tirangles

void showTriNormals() {vec N= new vec(0,0,0);                                             // renders tirangle normals with length 20
  for (int i=0; i<nt; i++) {N.setToVec(Nt[i]); N.makeUnit(); N.mul(20); N.show(triCenter(i)); };
  for (int i=0; i<nv; i++) {N.setToVec(Nv[i]); N.div(10); N.show(G[i]); };
  };

void writeTri (int i) {println("T"+i+": V = ("+V[3*i]+","+V[3*i+1]+","+V[3*i+2]+"), O = ("+O[3*i]+","+O[3*i+1]+","+O[3*i+2]+")"); };

void computeBox() {
  pt Lbox =  G[0].make();  pt Hbox =  G[0].make();
  for (int i=1; i<nv; i++) { 
    Lbox.x=min(Lbox.x,G[i].x); Lbox.y=min(Lbox.y,G[i].y); Lbox.z=min(Lbox.z,G[i].z);
    Hbox.x=max(Hbox.x,G[i].x); Hbox.y=max(Hbox.y,G[i].y); Hbox.z=max(Hbox.z,G[i].z); 
    };
  Cbox.setToPoint(midPt(Lbox,Hbox));  Rbox=Cbox.disTo(Hbox);
  println("Box r="+Rbox); print("C="); Cbox.write(); print("L="); Lbox.write(); print("H="); Hbox.write();
  };
